diff -rc --new-file -x Makefile -x depend -x *.orig -x *.o -x *.info* -x config.status -x *.a -x nohup.* -x Make.pack -x tests -x target-mkfrag -x dbz -x alloca-conf.h libg++-2.5.3/libio/iotempname.c libg++-2.5.3linux.2/libio/iotempname.c
*** libg++-2.5.3/libio/iotempname.c	Wed Dec 31 19:00:00 1969
--- libg++-2.5.3linux.2/libio/iotempname.c	Mon Dec 20 08:54:30 1993
***************
*** 0 ****
--- 1,238 ----
+ /* Copyright (C) 1991, 1992, 1993 Free Software Foundation, Inc.
+ This file is part of the GNU C Library.
+ 
+ The GNU C Library is free software; you can redistribute it and/or
+ modify it under the terms of the GNU Library General Public License as
+ published by the Free Software Foundation; either version 2 of the
+ License, or (at your option) any later version.
+ 
+ The GNU C Library is distributed in the hope that it will be useful,
+ but WITHOUT ANY WARRANTY; without even the implied warranty of
+ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ Library General Public License for more details.
+ 
+ You should have received a copy of the GNU Library General Public
+ License along with the GNU C Library; see the file COPYING.LIB.  If
+ not, write to the Free Software Foundation, Inc., 675 Mass Ave,
+ Cambridge, MA 02139, USA.  */
+ 
+ #include <ansidecl.h>
+ #include <errno.h>
+ #ifdef __STDC__
+ #include <stddef.h>
+ #endif
+ #include <stdlib.h>
+ #include <string.h>
+ #include <sys/types.h>
+ #include <sys/stat.h>
+ #include <fcntl.h>
+ #include <unistd.h>
+ #include "libioP.h"
+ #include "stdio.h"
+ 
+ #ifndef _IO_open
+ #define _IO_open open
+ #endif
+ 
+ #ifndef _IO_close
+ #define _IO_close close
+ #endif
+ 
+ #ifndef _IO_stat
+ #define _IO_stat stat
+ #endif
+ 
+ #ifndef _IO_getpid
+ #define _IO_getpid getpid
+ #endif
+ 
+ #ifndef _IO_geteuid
+ #define _IO_geteuid geteuid
+ #endif
+ 
+ /* Return nonzero if DIR is an existent directory.  */
+ static int
+ DEFUN(diraccess, (dir), CONST char *dir)
+ {
+   struct stat buf;
+   _IO_uid_t euid;
+ 
+   if (_IO_stat(dir, &buf) != 0 || !S_ISDIR(buf.st_mode)) return 0;
+ 
+   /* That is going to be tough. */
+ 
+   euid = _IO_geteuid ();
+   
+   /* super user */
+   if (!euid) return 1;
+ 
+   if (euid == buf.st_uid)
+     return ((buf.st_mode & S_IWUSR) && (buf.st_mode & S_IXUSR));
+ 
+   if (_IO_getegid () == buf.st_gid)
+     return ((buf.st_mode & S_IWGRP) && (buf.st_mode & S_IXGRP));
+ 
+   return ((buf.st_mode & S_IWOTH) && (buf.st_mode & S_IXOTH));
+ }
+ 
+ 
+ /* Return nonzero if FILE exists.  */
+ static int
+ DEFUN(exists, (file), CONST char *file)
+ {
+   /* We can stat the file even if we can't read its data.  */
+   struct stat st;
+   int save = errno;
+   if (_IO_stat (file, &st) == 0)
+     return 1;
+   else
+     {
+       /* We report that the file exists if stat failed for a reason other
+ 	 than nonexistence.  In this case, it may or may not exist, and we
+ 	 don't know; but reporting that it does exist will never cause any
+ 	 trouble, while reporting that it doesn't exist when it does would
+ 	 violate the interface of __stdio_gen_tempname.  */
+       int exists = errno != ENOENT;
+       errno = save;
+       return exists;
+     }
+ }
+ 
+ 
+ /* These are the characters used in temporary filenames.  */
+ static CONST char letters[] =
+   "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789";
+ 
+ /* Generate a temporary filename and return it (in a static buffer).  If
+    STREAMPTR is not NULL, open a stream "w+b" on the file and set
+    *STREAMPTR to it.  If DIR_SEARCH is nonzero, DIR and PFX are used as
+    described for tempnam.  If not, a temporary filename in P_tmpdir with no
+    special prefix is generated.  If LENPTR is not NULL, *LENPTR is set the
+    to length (including the terminating '\0') of the resultant filename,
+    which is returned.  This goes through a cyclic pattern of all possible
+    filenames consisting of five decimal digits of the current pid and three
+    of the characters in `letters'.  Data for tempnam and tmpnam is kept
+    separate, but when tempnam is using P_tmpdir and no prefix (i.e, it is
+    identical to tmpnam), the same data is used.  Each potential filename is
+    tested for an already-existing file of the same name, and no name of an
+    existing file will be returned.  When the cycle reaches its end
+    (12345ZZZ), NULL is returned.  */
+ char *
+ DEFUN(_IO_gen_tempname, (dir, pfx, dir_search, lenptr, streamptr),
+       CONST char *dir AND CONST char *pfx AND
+       int dir_search AND _IO_size_t *lenptr AND
+       _IO_FILE **streamptr)
+ {
+   int saverrno = errno;
+   static CONST char tmpdir[] = P_tmpdir;
+   static struct
+     {
+       unsigned char digits [4];
+     } infos[2], *info;
+   static char buf[FILENAME_MAX];
+   static _IO_pid_t oldpid = (pid_t) 0;
+   _IO_pid_t pid = _IO_getpid();
+   register _IO_size_t len, plen, dlen;
+   int i, carry;
+ 
+   if (dir_search)
+     {
+       register CONST char *d = getenv("TMPDIR");
+       if (d != NULL && !diraccess(d))
+ 	d = NULL;
+       if (d == NULL && dir != NULL && diraccess(dir))
+ 	d = dir;
+       if (d == NULL && diraccess(tmpdir))
+ 	d = tmpdir;
+       if (d == NULL && diraccess("/tmp"))
+ 	d = "/tmp";
+       if (d == NULL)
+ 	{
+ 	  errno = ENOENT;
+ 	  return NULL;
+ 	}
+       dir = d;
+     }
+   else
+     dir = tmpdir;
+ 
+   dlen = strlen (dir);
+ 
+   /* Remove trailing slashes from the directory name.  */
+   while (dlen > 1 && dir[dlen - 1] == '/')
+     --dlen;
+ 
+   if (pfx != NULL && *pfx != '\0')
+     {
+       plen = strlen(pfx);
+       if (plen > 5)
+ 	plen = 5;
+     }
+   else
+     plen = 0;
+ 
+   if (dir != tmpdir && !strcmp(dir, tmpdir))
+     dir = tmpdir;
+   info = &infos[(plen == 0 && dir == tmpdir) ? 1 : 0];
+ 
+   if (pid != oldpid)
+     {
+       oldpid = pid;
+       for (i = 0; i < sizeof (info->digits); i++)
+ 	infos[0].digits[i] = infos[1].digits[i] = 0;
+     }
+ 
+   len = dlen + 1 + plen + 5;
+   for (;;)
+     {
+       if (info->digits [sizeof (info->digits) - 1])
+ 	{
+ 	  errno = EEXIST;
+ 	  return NULL;
+ 	}
+ 
+       if ((sizeof (buf) - sizeof (info->digits)) < len ||
+ 		sprintf(buf, "%.*s/%.*s%.5d", (int) dlen, dir,
+ 		(int) plen, pfx, pid % 100000) != (int) len)
+ 	return NULL;
+ 
+       /* Get the last part of string */
+       for (i = 0; i < sizeof (info->digits) - 1; i++)
+         buf [len++] = letters [info->digits [i]];
+       buf [len] = '\0';
+ 
+       /* Always return a unique string.  */
+       carry = ++info->digits [0] / (sizeof (letters) - 1);
+       info->digits [0] %= (sizeof (letters) - 1);
+       for (i = 1; i < sizeof (info->digits); i++) {
+ 	  info->digits [i] += carry;
+ 	  carry = info->digits [i] / (sizeof (letters) - 1);
+ 	  info->digits [i] %= (sizeof (letters) - 1);
+       }
+ 
+       if (streamptr != NULL)
+ 	{
+ 	  int fd = _IO_open (buf, O_RDWR|O_CREAT|O_EXCL, 0666);
+ 	  if (fd >= 0)
+ 	    {
+ 	      *streamptr = _IO_fdopen (fd, "w+b");
+ 	      if (*streamptr == NULL)
+ 		{
+ 		  int save = errno;
+ 		  (void) _IO_close (fd);
+ 		  errno = save;
+ 		  return NULL;
+ 		}
+ 	      break;
+ 	    }
+ 	}
+       else if (!exists (buf))
+ 	break;
+     }
+ 
+   errno = saverrno;
+ 
+   if (lenptr != NULL)
+     *lenptr = len + 1;
+   return buf;
+ }
diff -rc --new-file -x Makefile -x depend -x *.orig -x *.o -x *.info* -x config.status -x *.a -x nohup.* -x Make.pack -x tests -x target-mkfrag -x dbz -x alloca-conf.h libg++-2.5.3/libio/ioungetc.c libg++-2.5.3linux.2/libio/ioungetc.c
*** libg++-2.5.3/libio/ioungetc.c	Mon Sep 27 17:46:35 1993
--- libg++-2.5.3linux.2/libio/ioungetc.c	Mon Feb 14 10:06:16 1994
***************
*** 29,34 ****
--- 29,35 ----
       int c;
       _IO_FILE *fp;
  {
+   CHECK_FILE(fp, EOF);
    COERCE_FILE(fp);
    if (c == EOF)
      return EOF;
diff -rc --new-file -x Makefile -x depend -x *.orig -x *.o -x *.info* -x config.status -x *.a -x nohup.* -x Make.pack -x tests -x target-mkfrag -x dbz -x alloca-conf.h libg++-2.5.3/libio/iovfprintf.c libg++-2.5.3linux.2/libio/iovfprintf.c
*** libg++-2.5.3/libio/iovfprintf.c	Wed Dec 22 06:40:01 1993
--- libg++-2.5.3linux.2/libio/iovfprintf.c	Mon Feb 14 10:39:04 1994
***************
*** 129,134 ****
--- 129,138 ----
    hp->_IO_write_base = buf;
    hp->_IO_write_ptr = buf;
    hp->_IO_write_end = buf+_IO_BUFSIZ;
+ 
+   /* TG: add because of Checker */
+   hp->_IO_file_flags = _IO_MAGIC|(_IO_IS_FILEBUF+_IO_NO_READS);
+ 
    hp->_jumps = &_IO_helper_jumps;
    
    /* Now print to helper instead. */
***************
*** 148,154 ****
  #include "floatio.h"
  #define	BUF		(MAXEXP+MAXFRACT+1)	/* + decimal point */
  #define	DEFPREC		6
! extern double modf _PARAMS((double, double*));
  
  #else /* no FLOATING_POINT */
  
--- 152,158 ----
  #include "floatio.h"
  #define	BUF		(MAXEXP+MAXFRACT+1)	/* + decimal point */
  #define	DEFPREC		6
! extern double modf __P((double, double*));
  
  #else /* no FLOATING_POINT */
  
diff -rc --new-file -x Makefile -x depend -x *.orig -x *.o -x *.info* -x config.status -x *.a -x nohup.* -x Make.pack -x tests -x target-mkfrag -x dbz -x alloca-conf.h libg++-2.5.3/libio/iovfscanf.c libg++-2.5.3linux.2/libio/iovfscanf.c
*** libg++-2.5.3/libio/iovfscanf.c	Wed Dec 22 06:40:01 1993
--- libg++-2.5.3linux.2/libio/iovfscanf.c	Mon Dec 20 08:54:30 1993
***************
*** 74,79 ****
--- 74,80 ----
  #define	SUPPRESS	0x08	/* suppress assignment */
  #define	POINTER		0x10	/* weird %p pointer (`fake hex') */
  #define	NOSKIP		0x20	/* do not skip blanks */
+ #define	WIDTH		0x40	/* width */
  
  /*
   * The following are used in numeric conversions only:
***************
*** 101,109 ****
  #define u_char unsigned char
  #define u_long unsigned long
  
! extern u_long strtoul _PARAMS((const char*, char**, int));
! extern long strtol _PARAMS((const char*, char**, int));
! static const u_char *__sccl _PARAMS((char *tab, const u_char *fmt));
  #ifndef USE_DTOA
  extern double atof();
  #endif
--- 102,110 ----
  #define u_char unsigned char
  #define u_long unsigned long
  
! extern u_long strtoul __P((const char*, char**, int));
! extern long strtol __P((const char*, char**, int));
! static const u_char *__sccl __P((char *tab, const u_char *fmt));
  #ifndef USE_DTOA
  extern double atof();
  #endif
***************
*** 123,135 ****
  	register _IO_ssize_t width;	/* field width, or 0 */
  	register char *p;	/* points into all kinds of strings */
  	register int n;		/* handy integer */
! 	register int flags;	/* flags as defined above */
  	register char *p0;	/* saves original value of p when necessary */
  	int nassigned;		/* number of fields assigned */
  	int nread;		/* number of characters consumed from fp */
  	/* Assignments to base and ccfn are just to suppress warnings from gcc.*/
  	int base = 0;		/* base argument to strtol/strtoul */
! 	typedef u_long (*strtoulfn) _PARAMS((const char*, char**, int));
  	strtoulfn ccfn = 0;
  	/* conversion function (strtol/strtoul) */
  	char ccltab[256];	/* character class table for %[...] */
--- 124,136 ----
  	register _IO_ssize_t width;	/* field width, or 0 */
  	register char *p;	/* points into all kinds of strings */
  	register int n;		/* handy integer */
! 	register int flags = 0;	/* flags as defined above */
  	register char *p0;	/* saves original value of p when necessary */
  	int nassigned;		/* number of fields assigned */
  	int nread;		/* number of characters consumed from fp */
  	/* Assignments to base and ccfn are just to suppress warnings from gcc.*/
  	int base = 0;		/* base argument to strtol/strtoul */
! 	typedef u_long (*strtoulfn) __P((const char*, char**, int));
  	strtoulfn ccfn = 0;
  	/* conversion function (strtol/strtoul) */
  	char ccltab[256];	/* character class table for %[...] */
***************
*** 149,157 ****
  		if (isspace(c)) {
  			for (;;) {
  			        c = _IO_getc(fp);
! 				if (c == EOF) {
! 				  seen_eof++;
! 				  break;
  				}
  				if (!isspace(c)) {
  				    _IO_ungetc (c, fp);
--- 150,159 ----
  		if (isspace(c)) {
  			for (;;) {
  			        c = _IO_getc(fp);
! 				if (c == EOF)
! 				{
! 				   seen_eof++;
! 				   break;
  				}
  				if (!isspace(c)) {
  				    _IO_ungetc (c, fp);
***************
*** 184,203 ****
  			continue;
  
  		case '*':
! 			flags |= SUPPRESS;
  			goto again;
  		case 'l':
  			flags |= LONG;
  			goto again;
  		case 'L':
  			flags |= LONGDBL;
  			goto again;
  		case 'h':
  			flags |= SHORT;
  			goto again;
  
  		case '0': case '1': case '2': case '3': case '4':
  		case '5': case '6': case '7': case '8': case '9':
  			width = width * 10 + c - '0';
  			goto again;
  
--- 186,211 ----
  			continue;
  
  		case '*':
! 			if (flags) goto control_failure;
! 			flags = SUPPRESS;
  			goto again;
  		case 'l':
+ 			if (flags & ~(SUPPRESS | WIDTH)) goto control_failure;
  			flags |= LONG;
  			goto again;
  		case 'L':
+ 			if (flags & ~(SUPPRESS | WIDTH)) goto control_failure;
  			flags |= LONGDBL;
  			goto again;
  		case 'h':
+ 			if (flags & ~(SUPPRESS | WIDTH)) goto control_failure;
  			flags |= SHORT;
  			goto again;
  
  		case '0': case '1': case '2': case '3': case '4':
  		case '5': case '6': case '7': case '8': case '9':
+ 			if (flags & ~(SUPPRESS | WIDTH)) goto control_failure;
+ 			flags |= WIDTH;
  			width = width * 10 + c - '0';
  			goto again;
  
***************
*** 666,671 ****
--- 674,680 ----
  	}
  eof_failure:
  	seen_eof++;
+ control_failure:
  input_failure:
  	if (nassigned == 0)
  	    nassigned = -1;
diff -rc --new-file -x Makefile -x depend -x *.orig -x *.o -x *.info* -x config.status -x *.a -x nohup.* -x Make.pack -x tests -x target-mkfrag -x dbz -x alloca-conf.h libg++-2.5.3/libio/isgetline.cc libg++-2.5.3linux.2/libio/isgetline.cc
*** libg++-2.5.3/libio/isgetline.cc	Fri Oct 22 00:54:32 1993
--- libg++-2.5.3linux.2/libio/isgetline.cc	Tue Feb 22 14:33:30 1994
***************
*** 29,66 ****
  istream& istream::getline(char* buf, int len, char delim)
  {
    _gcount = 0;
    if (ipfx1())
      {
        streambuf *sb = rdbuf();
!       long count = _IO_getline(sb, buf, len, delim, -1);
!       if (count == len-1)
! 	set(ios::failbit);
!       else {
! 	int ch = sb->sbumpc();
! 	if (ch == EOF)
! 	  set(ios::failbit|ios::eofbit);
! 	else if (ch == (unsigned char)delim)
! 	  count++;
! 	else
  	  sb->sungetc(); // Leave delimiter unread.
!       }
        _gcount = count;
      }
    return *this;
  }
  
  istream& istream::get(char* buf, int len, char delim)
  {
    _gcount = 0;
    if (ipfx1())
      {
        streambuf *sbuf = rdbuf();
!       long count = _IO_getline(sbuf, buf, len, delim, -1);
!       if (count < 0 || (count == 0 && sbuf->sgetc() == EOF))
  	set(ios::failbit|ios::eofbit);
        else
  	_gcount = count;
      }
    return *this;
  }
  
--- 29,75 ----
  istream& istream::getline(char* buf, int len, char delim)
  {
    _gcount = 0;
+   if (len <= 0)
+     {
+       set(ios::failbit);
+       return *this;
+     }
    if (ipfx1())
      {
        streambuf *sb = rdbuf();
!       _IO_size_t count = _IO_getline(sb, buf, len - 1, delim, -1);
!       int ch = sb->sbumpc();
!       if (ch == EOF)
! 	set(ios::failbit|ios::eofbit);
!       else if (ch != (unsigned char)delim)
! 	{
! 	  set(ios::failbit);
  	  sb->sungetc(); // Leave delimiter unread.
! 	}
        _gcount = count;
      }
+   buf[_gcount] = '\0';
    return *this;
  }
  
  istream& istream::get(char* buf, int len, char delim)
  {
    _gcount = 0;
+   if (len <= 0)
+     {
+       set(ios::failbit);
+       return *this;
+     }
    if (ipfx1())
      {
        streambuf *sbuf = rdbuf();
!       long count = _IO_getline(sbuf, buf, len - 1, delim, -1);
!       if (count == 0 && sbuf->sgetc() == EOF)
  	set(ios::failbit|ios::eofbit);
        else
  	_gcount = count;
      }
+   buf[_gcount] = '\0';
    return *this;
  }
  
***************
*** 75,87 ****
  
  char *_sb_readline (streambuf *sb, long& total, char terminator) 
  {
!     char buf[CHUNK_SIZE+1];
      char *ptr;
      int ch;
      
!     long count = sb->sgetline(buf, CHUNK_SIZE+1, terminator, -1);
!     if (count == EOF)
! 	return NULL;
      ch = sb->sbumpc();
      long old_total = total;
      total += count;
--- 84,94 ----
  
  char *_sb_readline (streambuf *sb, long& total, char terminator) 
  {
!     char buf[CHUNK_SIZE];
      char *ptr;
      int ch;
      
!     _IO_size_t count = _IO_getline(sb, buf, CHUNK_SIZE, terminator, -1);
      ch = sb->sbumpc();
      long old_total = total;
      total += count;
diff -rc --new-file -x Makefile -x depend -x *.orig -x *.o -x *.info* -x config.status -x *.a -x nohup.* -x Make.pack -x tests -x target-mkfrag -x dbz -x alloca-conf.h libg++-2.5.3/libio/libio.h libg++-2.5.3linux.2/libio/libio.h
*** libg++-2.5.3/libio/libio.h	Fri Nov 26 17:05:49 1993
--- libg++-2.5.3linux.2/libio/libio.h	Tue Feb 22 14:38:26 1994
***************
*** 39,45 ****
--- 39,47 ----
  #define _IO_ssize_t _G_ssize_t
  #define _IO_off_t _G_off_t
  #define _IO_pid_t _G_pid_t
+ #define _IO_uid_t _G_uid_t
  #define _IO_HAVE_SYS_WAIT _G_HAVE_SYS_WAIT
+ #define _IO_HAVE_ST_BLKSIZE _G_HAVE_ST_BLKSIZE
  #define _IO_BUFSIZ _G_BUFSIZ
  #define _IO_va_list _G_va_list
  
***************
*** 58,73 ****
  typedef _IO_fpos_t _IO_pos_t;
  #endif
  
! #ifndef _PARAMS
! #ifdef __STDC__
! #define _PARAMS(paramlist) paramlist
! #else
! #define _PARAMS(paramlist) ()
! #endif
! #endif /*!_PARAMS*/
! #ifndef __STDC__
! #define const
! #endif
  #define USE_DTOA
  
  #if 0
--- 60,67 ----
  typedef _IO_fpos_t _IO_pos_t;
  #endif
  
! #include <sys/cdefs.h>
! 
  #define USE_DTOA
  
  #if 0
***************
*** 213,219 ****
  
  struct _IO_FILE_plus {
    _IO_FILE _file;
!   const void *_vtable;
  };
  
  extern struct _IO_FILE_plus _IO_stdin_, _IO_stdout_, _IO_stderr_;
--- 207,213 ----
  
  struct _IO_FILE_plus {
    _IO_FILE _file;
!   __const void *_vtable;
  };
  
  extern struct _IO_FILE_plus _IO_stdin_, _IO_stdout_, _IO_stderr_;
***************
*** 225,234 ****
  extern "C" {
  #endif
  
! extern int __underflow _PARAMS((_IO_FILE*));
! extern int __overflow _PARAMS((_IO_FILE*, int));
  
! extern unsigned __adjust_column _PARAMS((unsigned start, const char *line, int count));
  
  #define _IO_getc(_fp) \
         ((_fp)->_IO_read_ptr >= (_fp)->_IO_read_end \
--- 219,228 ----
  extern "C" {
  #endif
  
! extern int __underflow __P((_IO_FILE*));
! extern int __overflow __P((_IO_FILE*, int));
  
! extern unsigned __adjust_column __P((unsigned start, __const char *line, int count));
  
  #define _IO_getc(_fp) \
         ((_fp)->_IO_read_ptr >= (_fp)->_IO_read_end \
***************
*** 241,255 ****
  
  #define _IO_putc(_ch, _fp) \
     (((_fp)->_IO_write_ptr >= (_fp)->_IO_write_end) \
!     ? __overflow(_fp, (unsigned char)_ch) \
!     : (unsigned char)(*(_fp)->_IO_write_ptr++ = _ch))
  
! extern int _IO_vfscanf _PARAMS((_IO_FILE*, const char*, _IO_va_list, int*));
! extern int _IO_vfprintf _PARAMS((_IO_FILE*, const char*, _IO_va_list));
! extern _IO_ssize_t _IO_padn _PARAMS((_IO_FILE *, int, _IO_ssize_t));
! extern _IO_size_t _IO_sgetn _PARAMS((_IO_FILE *, void*, _IO_size_t));
  
! extern void _IO_free_backup_area _PARAMS((_IO_FILE*));
  
  #ifdef __cplusplus
  }
--- 235,253 ----
  
  #define _IO_putc(_ch, _fp) \
     (((_fp)->_IO_write_ptr >= (_fp)->_IO_write_end) \
!     ? __overflow(_fp, (unsigned char)(_ch)) \
!     : (unsigned char)(*(_fp)->_IO_write_ptr++ = (_ch)))
  
! /* This one is for Emacs. */
! #define _IO_PENDING_OUTPUT_COUNT(_fp)	\
! 	((_fp)->_IO_write_ptr - (_fp)->_IO_write_base)
! 
! extern int _IO_vfscanf __P((_IO_FILE*, __const char*, _IO_va_list, int*));
! extern int _IO_vfprintf __P((_IO_FILE*, __const char*, _IO_va_list));
! extern _IO_ssize_t _IO_padn __P((_IO_FILE *, int, _IO_ssize_t));
! extern _IO_size_t _IO_sgetn __P((_IO_FILE *, void*, _IO_size_t));
  
! extern void _IO_free_backup_area __P((_IO_FILE*));
  
  #ifdef __cplusplus
  }
